class MTel expands KeyPoint;

var Teleporter MyT;
var bool bDestOnly;
var bool bTiming;
var float TWait;
var Actor Kicked;
var int Attempt;

event PostBeginPlay()
{
	InitialState = 'SettingUp';
}

function DoSetup()
{
	if (Teleporter(Owner) != None)
	{
		MyT = Teleporter(Owner);
		log (Self$" successfully got Teleporter "$MyT);
		SetCollisionSize(FClamp( MyT.CollisionRadius+0.5,MyT.CollisionRadius+0.5,200 )
			,FClamp( MyT.CollisionHeight+0.5,MyT.CollisionHeight+0.5,200 ) );
		if ( MyT.URL ~= "" )
			bDestOnly = True;
	}
}

event Touch( Actor Other )
{
	Kicked = Other;
	GoToState('Tracking','Touched');
//	Log(Self.Name@"Touched by"@Other.GetHumanName());
}

event UnTouch( Actor Other )
{
	Kicked = Other;
	GotoState('Tracking','UnTouched');
//	Log(Self.Name@"UnTouched by"@Other.GetHumanName());
}

final function CheckIfGone(Actor Other)
{
	local Pawn P;
	local bool bIsHere;
	local Teleporter T;

//	Log(Self.Name@"Querry > Is Gone"@Other.GetHumanName());
	if (MyT != None)
	{
		foreach RadiusActors (class 'Pawn',P,CollisionRadius+15)
		{
			if ( P.Health > 0 )
			{
				bIsHere = True;
				Kicked = P;
				break;
			}
		}
		if ( bIsHere )
		{
			if ( VSize(Kicked.Velocity) < 50)
			{
				foreach AllActors (class'Teleporter',T)
				{
					if ( string(MyT.tag)~= T.URL && T.bCollideActors)
						T.SetCollision(False,False,False);
				}
				MyT.SetCollision(False,False,False);
//				SetTimer(0.3,False);
				TWait = 0.3;
				bTiming = True;
				DoKick(Kicked);
			}
		}
	}
}

final function SetOrKick(Actor Other)
{
	local Teleporter T;

//	Log(Self.Name@"Kick check at"@Other.GetHumanName());
	if ( MyT != None )
	{
		MyT.SetCollision(False,False,False);
		Myt.ExtraCost = 100000000;
		TWait = 0.5;
		bTiming = True;
//		SetTimer(0.5,False);
		foreach AllActors (class'Teleporter',T)
		{
			if ( string(MyT.tag)~= T.URL && T.bCollideActors)
				T.SetCollision(False,False,False);
		}
		if ( Pawn(Other) != None && VSize(Other.Velocity) < 50 && Pawn(Other).Health > 0 )
			DoKick(Other);
	}
}

function DoKick(Actor Other)
{
	local bool bWasFalling, bRandomize, bKillVelocity;
	local vector Push;
	local float PMag;
	local vector KickVelocity;

	KickVelocity.X = 0;
	KickVelocity.Y = 0;
	KickVelocity.Z += 320;
	bRandomize = True;
	bKillVelocity = True;

	bWasFalling = ( Other.Physics == PHYS_Falling ); //Stupid kicker code bellow ++
	if ( bKillVelocity )
		Push = -1 * Other.Velocity;
	else
		Push.Z = -1 * Other.Velocity.Z;
	if ( bRandomize )
	{
		PMag = VSize(KickVelocity);
		Push += PMag * Normal(KickVelocity + 0.5 * PMag * VRand());
	}
	else
		Push += KickVelocity;
	if ( Other.IsA('Bot') && !Other.Region.Zone.bWaterZone )
	{
		if ( bWasFalling )
		{
			Bot(Other).bJumpOffPawn = True;
			Bot(Other).SetFall();
		}
	}
	if ( !Other.Region.Zone.bWaterZone )	// ADD: Reason -> For sure we don't fall in water, you just fuck Bot here, you "smart genius" !!
		Other.SetPhysics(PHYS_Falling);		// You could not code properly 5 classes one by one after all.
	Other.Velocity += Push;
}

final function TimeKick()
{
	local int i;
	local bool bKeepOff;
	local Teleporter T;
	local Pawn P;

//	Log(Self.Name@"Query for Tel still busy...");
	Kicked = None;
	if ( MyT != None )
	{
		for (i=0;i<4;i++)
			if ( Touching[i] != None && Pawn(Touching[i]) != None && VSize(Pawn(Touching[i]).Velocity) < 50
			&& Pawn(Touching[i]).Health > 0 )
			{
				Attempt++;
				if ( Attempt > 3 )
				{
					Attempt = 0;
					ExplodeIt();
				}
				if ( Pawn(Touching[i]) != None && Pawn(Touching[i]).Health > 0 ) //check if did not die after this
				{
					DoKick(Pawn(Touching[i]));
					bKeepOff = True;
				}
			}
		foreach RadiusActors (class 'Pawn',P,CollisionRadius+15)
		{
			if ( P.Health > 0 )
			{
				bKeepOff = True;
				Kicked = P;
				break;
			}
		}
		if ( bKeepOff )
		{
			if ( Kicked != None )
			{
				Attempt++;
				if ( Attempt > 3 )
				{
					Attempt = 0;
					ExplodeIt();
				}
				if ( Pawn(Kicked) != None && Pawn(Kicked).Health > 0 )
					DoKick(Kicked);
			}
			TWait = 0.5;
//			SetTimer(0.5,False);
			bTiming = True;
			GotoState('Tracking','TimingHere');
			return;
		}
		else
		{
			Attempt = 0;
			if (!bDestOnly)
				MyT.SetCollision(True,False,False);
			MyT.ExtraCost = 0;
			foreach AllActors (class'Teleporter',T)
			{
				if ( string(MyT.tag)~= T.URL && !T.bCollideActors)
					T.SetCollision(True,False,False);
			}
		}
	}
}

function ExplodeIt()
{
	Spawn ( class'UT_ComboRing',,,Location );
	HurtRadius(200,400,'Collidized',50000,Location);
	BroadcastMessage(Self.Name$" detected abnormal presence in"$MyT.Name$"'s radius. Attempting damaging solution...",False);
}

Auto State SettingUp
{
Begin:
	Sleep(1.00);
	DoSetup();
	GotoState('Tracking','Begin');
End:
}

State Tracking
{
Touched:
	Sleep(0.00);
	if ( Kicked != None )
		SetOrKick(Kicked);
TimingHere:
	Sleep(TWait+0.1);
	if ( bTiming )
	{
		bTiming = False;
		TimeKick();
	}
	GoTo('Begin');
UnTouched:
	if ( Kicked != None )
		CheckIfGone(Kicked);
	if ( bTiming )
		GoTo('TimingHere');
	else
		GoTo('Begin');
Begin:
	Kicked = None; //Need to reset Kicked after operating
// Do not react if is not needed - default
}

defaultproperties
{
   bGameRelevant=True
   bMovable=False
   bStatic=False
   bCollideActors=True
}